﻿/*
 * Copyright(c) 2009 cuegraphix.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

package com.cuegraphix.events 
{
	import com.cuegraphix.layouts.LiquidLayout;
	import flash.events.Event;
	
	/**
	* Leyoutサイズ変更時に送出されるイベントクラス。
	* @author cue
	*/
	public class LiquidLayoutEvent extends Event 
	{
		/**
		 * リサイズ中のresizeAlwaysイベントオブジェクトのtype定義
		 */
		public static const RESIZE_ALWAYS:String   = "resizeAlways";
		
		/**
		 * リサイズが開始されたresizeStartイベントオブジェクトのtype定義
		 */
		public static const RESIZE_START:String = "resizeStart";
		
		/**
		 * リサイズが実行中のresizeProgressイベントオブジェクトのtype定義
		 */
		public static const RESIZE_PROGRESS:String = "resizeProgress";
		
		/**
		 * リサイズが完了したresizeCompleteイベントオブジェクトのtype定義
		 */
		public static const RESIZE_COMPLETE:String = "resizeComplete";
		
		private var _layout:LiquidLayout;
		public function get layout():LiquidLayout
		{
			return _layout;
		}
		
		public function LiquidLayoutEvent(type:String, bubbles:Boolean=false, cancelable:Boolean=false, layout:LiquidLayout = null) 
		{
			super(type, bubbles, cancelable);
			_layout = layout;
		} 
		
		public override function clone():Event 
		{
			return new LiquidLayoutEvent(type, bubbles, cancelable, layout);
		} 
		
		public override function toString():String 
		{
			return formatToString("LiquidLayoutEvent", "type", "bubbles", "cancelable", "eventPhase"); 
		}
		
	}
	
}