﻿/**
 * 
 */
package layouttest {
	import com.cuegraphix.layouts.LiquidLayout;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.MouseEvent;
	import jp.progression.casts.*;
	import jp.progression.commands.*;
	import jp.progression.core.debug.Verbose;
	import jp.progression.events.*;
	import jp.progression.loader.*;
	import jp.progression.*;
	import jp.progression.scenes.*;
	import org.libspark.ui.SWFWheel;

	
	/**
	 * Index クラス
	 */
	public class Index extends CastDocument {
		
		/**
		 * Progression インスタンスを取得します。
		 */
		public var prog:Progression;
		
		
		public static var layout:LiquidLayout;
		
		public static var container:Sprite;
		
		public static var stageContoller:StageController;
		
		/**
		 * コンストラクタ
		 */
		public function Index() {
		}
		
		
		
		
		
		/**
		 * SWF ファイルの読み込みが完了し、stage 及び loaderInfo にアクセス可能になった場合に送出されます。
		 */
		protected override function _onInit():void {
			// stage の初期設定を行います。
			align = StageAlign.TOP_LEFT;
			quality = StageQuality.HIGH;
			scaleMode = StageScaleMode.NO_SCALE;
			
			layout = new LiquidLayout( this );
			container = new Sprite();
			stageContoller = new StageController();
			layout.addLayout( stageContoller, { onResize: stageContoller.onResize } );
			
			graphics.lineStyle( 0, 0x000000 );
			graphics.drawRect( 0, 0, layout.contentWidth, layout.contentHeight );
			
			// SWFWheel を有効化する
			SWFWheel.initialize( stage );
			
			// 開発者用の出力を有効化します。
			//Verbose.enabled = true;
			//Verbose.filteringCommand();
			
			// Progression インスタンスを作成します。
			prog = new Progression( "index", stage, IndexScene );
			
			prog.container.addChild( container );
			
			prog.container.addChild( stageContoller );
			
			// ブラウザ再生時に URL 同期を有効化します。
			prog.sync = true;
			
			// 最初のシーンに移動します。
			prog.goto( prog.firstSceneId );
		}
		
		
		
		public static function createRect( caption:String, color:int = 0xFF0000, width:Number = 100, height:Number = 100, x:Number = 0, y:Number = 0 ):CastSprite
		{
			var sp:CastSprite = new CastSprite();
			sp.toolTip.text = caption;
			sp.buttonMode = true;
			sp.addEventListener( MouseEvent.CLICK, function( e:MouseEvent ):void { Index.layout.setEnableLayout( e.currentTarget, !Index.layout.isEnabled( e.currentTarget ) ); } );
			sp.graphics.beginFill( color, 1 );
			sp.graphics.drawRect( x, y, width, height );
			sp.graphics.endFill();
			return sp;
		}
	}
}








