﻿/**
 * 
 */
package layouttest
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import jp.progression.casts.CastDocument;
	import jp.progression.casts.CastSprite;
	import jp.progression.commands.DoTweener;
	import jp.progression.commands.Goto;
	import jp.progression.commands.SerialList;
	import jp.progression.scenes.SceneId;
	import jp.progression.scenes.SceneObject;
	
	/**
	 * IndexScene クラス
	 */
	public class IndexScene extends SceneObject
	{
		public var lt:CastSprite;
		public var ct:CastSprite;
		public var rt:CastSprite;
		public var lm:CastSprite;
		public var cm:CastSprite;
		public var rm:CastSprite;
		public var lb:CastSprite;
		public var cb:CastSprite;
		public var rb:CastSprite;
		
		/**
		 * コンストラクタ
		 */
		public function IndexScene()
		{
			// ブラウザ同期時に出力したいタイトルを設定します。
			title = "DocuemntLayout";
			
			addScene( new PositionScene( "position" ) );
			addScene( new SizeScene( "size" ) );
			addScene( new DoTweenerScene( "tween" ) );
			addScene( new CostomPropertyScene( "costom" ) );
			addScene( new ProportionScene( "proportion" ) );
		}
		
		/**
		 * シーンオブジェクトが目的地だった場合に、到達した瞬間に送出されます。
		 * このイベント処理の実行中には、addCommand() メソッド、及び insertCommand() メソッドによるコマンドの同期処理が行えます。
		 */
		protected override function _onInit():void
		{
			addCommand(
				new Goto( new SceneId( "/index/position" ) )
			);
		}
	}
}









