﻿/**
 * 
 */
package layouttest
{
	import com.cuegraphix.layouts.properties.ConstrainProportions;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import jp.progression.casts.CastDocument;
	import jp.progression.casts.CastImageLoader;
	import jp.progression.casts.CastSprite;
	import jp.progression.commands.AddChild;
	import jp.progression.commands.DoTweener;
	import jp.progression.commands.LoadChild;
	import jp.progression.commands.SerialList;
	import jp.progression.scenes.SceneObject;
	
	/**
	 * IndexScene クラス
	 */
	public class ProportionScene extends SceneObject
	{
		public var photo:CastSprite;
		
		
		/**
		 * コンストラクタ
		 */
		public function ProportionScene( name:String = null )
		{
			super( name );
			// ブラウザ同期時に出力したいタイトルを設定します。
			title = "比率を固定 | DocuemntLayout";
			
			ConstrainProportions.init();
		}
		
		/**
		 * シーンオブジェクトが目的地だった場合に、到達した瞬間に送出されます。
		 * このイベント処理の実行中には、addCommand() メソッド、及び insertCommand() メソッドによるコマンドの同期処理が行えます。
		 */
		protected override function _onInit():void
		{
			
			Index.stageContoller.message = "DocumentLayout ではスペシャルプロパティを使って拡張できるようになっています。この例は背景画像のように比率を固定したまま拡大縮小を行いたい場合に ConstrainProportions というスペシャルプロパティを使用します。";
			
			photo = new CastSprite();
			
			addCommand(
				new LoadChild( photo, new URLRequest( "sora.jpg" ) ),
				function():void {
					Index.layout.addLayout( photo, { outside: 0 } );
				},
				new AddChild( Index.container, photo )
			);
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは親階層だった場合に、階層が変更された瞬間に送出されます。
		 * このイベント処理の実行中には、addCommand() メソッド、及び insertCommand() メソッドによるコマンドの同期処理が行えます。
		 */
		protected override function _onUnload():void
		{
			Index.layout.removeLayout( photo );
			
			Index.container.removeChild( photo );
			
			photo = null;
		}
	}
}









